;
; Created on Sunday, 11 of June 2017 at 09:43 AM
;
; ZX Spectrum Next Framework V0.1 by Mike Dailly, 2017
;
; 
                opt             sna=StartAddress:StackStart                             ; save SNA,Set PC = run point in SNA file and TOP of stack
                opt             Z80                                                                             ; Set z80 mode

                include "includes.asm"


                ; IRQ is at $5c5c to 5e01
                include "irq.asm"       
               
StackEnd:
                ds      127
StackStart:     db      0

                org     $6100


StartAddress:
                di
                ld      a,VectorTable>>8
                ld      i,a                     
                im      2                       ; Setup IM2 mode
                ei
                ld      a,0
                out     ($fe),a

                ; enable turbo mode  (not sure what 14Mhz is yet)
                ;ld      bc, $243B
                ;ld      a,7                     ; select reg 6
                ;out     (c),a
                ;ld      bc, $253B
                ;ld      a,1                     ; set 7Mhz turbo mode
                ;out     (c),a

                ld      a,7
                call    ClsATTR

                call    InitFilesystem

                ld      a,$e3                    ; Clear screen to transparent
                call    Cls256
                
                ;ld      hl,XeO3TitleFile
                ;call    Load256Screen           ; load screen and display it
                ld      hl,LemDemoFile
                call    Load256Screen           ; load screen and display it

                ;ld      a,$e3                   ; screen is transparent
                ;call    Cls256

                call    InitSprites
                call    InitMap



                ld      a,0                     ; black boarder
                out     ($fe),a


                LoadFile        PygFile,$4000   ; load Pyjamarama loading screen (test)
;
;       Main loop
;               
MainLoop:
                halt                            ; wait for vblanks (need to do Raster IRQs at some point)

                
                ; timing bar
                ld      a,1
                out     ($fe),a

                call    ScrollMap
                call    BounceSprites

                ; timing bar off
                ld      a,0
                out     ($fe),a

                jp      MainLoop                ; infinite loop


; *****************************************************************************************************************************
; includes modules
; *****************************************************************************************************************************
                include "Scroll.asm"
                include "Utils.asm"
                include "SpriteBouncing.asm"
                include "filesys.asm"


; *****************************************************************************************************************************
; File directory.....
; *****************************************************************************************************************************
LemDemoFile     File    "game/lem.256"
XeO3TitleFile   File    "game/xeo3tit.256"
Level1File      File    "game/xeo3.map"
LevelCharsFile  File    "game/xeo3ch.256"
SpriteFile      File    "game/minecraf.spr"
PygFile         File    "game/pyj.scr"



                ; wheres our end address?
                message "End of code =",PC
        



